Subject: Re: tb/cruft-packs (was Re: What's cooking in git.git (Mar 2022, #01; Thu, 3))

From: Junio C Hamano <[email-masked]>
Date: Mon, 07 Mar 2022 13:34:57 -0800

Derrick Stolee <[email-masked]> writes:

> ... Git does not
> support parallel writers doing significant updates like full
> repacks and GCs and instead relies on the user to control the
> concurrency there.

At least when we set out to give our users Git, allowing such
concurrent writing without corrupting repositories was what we aimed
to achieve.  If you did two simultanenous repacks, one of the may
fail while trying to acquire a lock or two, so from waste-avoidance
perspective, there is a strong incentive on the user's side to make
sure such housecleaning tasks are not triggered needlessly and
simultanously, but it shouldn't lead to repository corruption.

Have we broken that over the course of adding new commits and
developers?  If so, we have stuff that needs fixing, and also ensure
that the developer and end-user expectations are aligned.

Thanks.